Qt Reference Documentation

# QQueue Class Reference

The QQueue class is a generic container that provides a queue. More...

     #include <QQueue>

Inherits: QList<T>.

Note: All functions in this class are reentrant.

- List of all members, including inherited members

## Public Functions

| QQueue ()
| ~QQueue ()
T | dequeue ()
void | enqueue ( const T & t )
T & | head ()
const T & | head () const
void | swap ( QQueue<T> & other )

- 67 public functions inherited from QList

### Additional Inherited Members

- 3 static public members inherited from QList

## Detailed Description

The QQueue class is a generic container that provides a queue.

QQueue<T> is one of Qt's generic container classes. It implements a queue data structure for items of a same type.

A queue is a first in, first out (FIFO) structure. Items are added to the tail of the queue using enqueue() and retrieved from the head using dequeue(). The head() function provides access to the head item without removing it.

Example:

     QQueue<int> queue;
     queue.enqueue(1);
     queue.enqueue(2);
     queue.enqueue(3);
     while (!queue.isEmpty())
         cout << queue.dequeue() << endl;

The example will output 1, 2, 3 in that order.

QQueue inherits from QList. All of QList's functionality also applies to QQueue. For example, you can use isEmpty() to test whether the queue is empty, and you can traverse a QQueue using QList's iterator classes (for example, QListIterator). But in addition, QQueue provides three convenience functions that make it easy to implement FIFO semantics: enqueue(), dequeue(), and head().

QQueue's value type must be an assignable data type. This covers most data types that are commonly used, but the compiler won't let you, for example, store a QWidget as a value. Use QWidget* instead.

See also QList and QStack.

## Member Function Documentation

### QQueue::QQueue ()

Constructs an empty queue.

### QQueue::~QQueue ()

Destroys the queue. References to the values in the queue, and all iterators over this queue, become invalid.

### T QQueue::dequeue ()

Removes the head item in the queue and returns it. This function assumes that the queue isn't empty.

This is the same as QList::takeFirst().

See also head(), enqueue(), and isEmpty().

### void QQueue::enqueue ( const T & t )

Adds value t to the tail of the queue.

This is the same as QList::append().

See also dequeue() and head().

### T & QQueue::head ()

Returns a reference to the queue's head item. This function assumes that the queue isn't empty.

This is the same as QList::first().

See also dequeue(), enqueue(), and isEmpty().

### const T & QQueue::head () const

This is an overloaded function.

### void QQueue::swap ( QQueue<T> & other )

Swaps queue other with this queue. This operation is very fast and never fails.

This function was introduced in Qt 4.8.